CFPRIME CALSTP                                                          CALSTP      1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
      SUBROUTINE  CALSTP                                                CALSTP      3
CD -------------------------------------------------------------------  CALSTP      4
CD                                                                      CALSTP      5
CD              *****     CALSTP  ROUTINE   *****                       CALSTP      6
CD                                                                      CALSTP      7
CD -------------------------------------------------------------------  CALSTP      8
CD                                                                      CALSTP      9
CD       PURPOSE: This routine calculates the number of steps           CALSTP     10
CD                of the control solution for each dc solution          CALSTP     11
CD                and the number of dc solutions for each aCD           CALSTP     12
CD                solution.                                             CALSTP     13
CD                                                                      CALSTP     14
CD                                                                      CALSTP     15
CD -------------------------------------------------------------------  CALSTP     16
      INCLUDE 'PARX.INS'                                                CALSTP     17
      INCLUDE 'GRDC01.INS'                                              CALSTP     18
      INCLUDE 'UDCG.INS'                                                CALSTP     19
      INCLUDE 'UDCJ.INS'                                                CALSTP     20
C                                                                       CALSTP     21
C---------------------------------------------------------------------  CALSTP     22
C                                                                       CALSTP     23
      IF (ABS(STIME) .GT. 0.0) THEN                                     CALSTP     24
         NDSTEP = INT ((DTIME / STIME) + 0.5 )                          CALSTP     25
         IF (NDSTEP .EQ. 0) NDSTEP = 1                                  CALSTP     26
      ELSE                                                              CALSTP     27
         NDSTEP = 1                                                     CALSTP     28
         STIME = DTIME                                                  CALSTP     29
      END IF                                                            CALSTP     30
C                                                                       CALSTP     31
      IF (ABS(CTIME) .GT. 0.0) THEN                                     CALSTP     32
         NCSTEP = INT ((STIME / CTIME) + 0.5 )                          CALSTP     33
         IF (NCSTEP .EQ. 0) NCSTEP = 1                                  CALSTP     34
         STIME = CTIME * REAL (NCSTEP)                                  CALSTP     35
      ELSE                                                              CALSTP     36
         NCSTEP = 1                                                     CALSTP     37
         CTIME = STIME                                                  CALSTP     38
      END IF                                                            CALSTP     39
C                                                                       CALSTP     40
C     Final fixup so that control step remains unchanged as does        CALSTP     41
C     the ac time step.                                                 CALSTP     42
C                                                                       CALSTP     43
      IF (ABS(STIME) .GT. 0.0) THEN                                     CALSTP     44
         NDSTEP = INT ((DTIME / STIME) + 0.5 )                          CALSTP     45
         IF (NDSTEP .EQ. 0) NDSTEP = 1                                  CALSTP     46
      END IF                                                            CALSTP     47
C                                                                       CALSTP     48
C---------------------------------------------------------------------  CALSTP     49
C                                                                       CALSTP     50
      RETURN                                                            CALSTP     51
C                                                                       CALSTP     52
C---------------------------------------------------------------------  CALSTP     53
C                                                                       CALSTP     54
      END                                                               CALSTP     55
